// C Source File
// Created 2/4/2008; 1:45:12 PM

//#include "itemtype.h"
//#include "item.h"

#include "C:\Users\Nick\Documents\C Programming\TI-89 files\MapleCal\MapleCal\itemtype.h"
#include "C:\Users\Nick\Documents\C Programming\TI-89 files\MapleCal\MapleCal\item.h"

//#include "C:\Users\Joseph\Desktop\Calculator Programing stuff\Maplecalc\MapleCal\itemtype.h"
//#include "C:\Users\Joseph\Desktop\Calculator Programing stuff\Maplecalc\MapleCal\item.h"

// Arrays of items
USEABLE_ITEM 			iUseable[NUM_USEABLE];
COLLECTABLE_ITEM 	iCollectable[NUM_COLLECTABLE];
AMMO_ITEM 				iAmmo[NUM_AMMO];
WEAPON_ITEM 			iWeapon[NUM_WEAPON];
ARMOR_ITEM 				iArmor[NUM_ARMOR];

#define NewUseableType(I, FOR, AMOUNT) iUseable[I].usedFor = FOR; iUseable[I].amount = AMOUNT;
#define NewAmmoType(I, DMG, TYPE, SPRITE) iAmmo[I].damage = DMG; iAmmo[I].type = TYPE; iAmmo[I].spriteIndex = SPRITE;
#define NewWeaponType(I, DMG, TYPE, SPRITE, WSPEED) iWeapon[I].damage = DMG; iWeapon[I].type = TYPE; iWeapon[I].spriteIndex = SPRITE; iWeapon[I].speed = WSPEED; 
#define NewArmorType(I, DEF, TYPE, SPRITE) iArmor[I].defense = DEF; iArmor[I].type = TYPE; iArmor[I].spriteIndex = SPRITE;

// Populates all of the arrays
void CreateItemTypes()
{
	// Potion
	NewUseableType(0, HP, 100);
	// Elixir
	NewUseableType(1, MP, 50);

	// Axes
	NewWeaponType(0, 32, AXE, 2, W_AVERAGE);		// Hunters Axe
	NewWeaponType(1, 42, AXE, 2, W_AVERAGE);		// Iron Axe
	NewWeaponType(2, 52, AXE, 2, W_SLOW);		// Steel Axe
	NewWeaponType(3, 62, AXE, 2, W_SLOW);		// Great Axe
	NewWeaponType(4, 97, AXE, 2, W_SLOW);		// Battle Axe

	// Swords
	NewWeaponType(5, 30, _SWORD, 0, W_FAST);// Dagger
	NewWeaponType(6, 40, _SWORD, 0, W_AVERAGE);// Short Sword
	NewWeaponType(7, 48, _SWORD, 0, W_AVERAGE);// Bastard Swd
	NewWeaponType(8, 60, _SWORD, 0, W_AVERAGE);// Long Sword
	NewWeaponType(9, 90, _SWORD, 0, W_AVERAGE);// Master Swd

	// Bows
	NewWeaponType(10, 25, BOW, 1, W_FASTEST);	// Shortbow
	NewWeaponType(11, 35, BOW, 1, W_FASTEST);	// Hunters Bow
	NewWeaponType(12, 45, BOW, 1, W_FASTEST);	// Oakbow
	NewWeaponType(13, 55, BOW, 1, W_FAST);	// Yewbow
	NewWeaponType(14, 85, BOW, 1, W_FAST);	// Ebonybow

	// Wands
	NewWeaponType(15, 23, WAND, 4, W_FASTEST);	// Nematode
	NewWeaponType(16, 33, WAND, 4, W_FASTEST);	// Scarab
	NewWeaponType(17, 43, WAND, 4, W_FASTEST);	// Werewolf
	NewWeaponType(18, 53, WAND, 4, W_FASTEST);	// Dragon
	NewWeaponType(19, 83, WAND, 4, W_FASTEST);	// Phoenix

	// Spears
	NewWeaponType(20, 32, SPEAR, 3, W_SLOW);// Wooden Spr
	NewWeaponType(21, 37, SPEAR, 3, W_SLOWEST);// Steel Spr
	NewWeaponType(22, 55, SPEAR, 3, W_SLOWEST);// Barbed Spr
	NewWeaponType(23, 72, SPEAR, 3, W_SLOWEST);// Halberd
	NewWeaponType(24, 97, SPEAR, 3, W_SLOWEST);// Dragon Bone

	// Ammo
	NewAmmoType(0, 0, _ARROW, 0);	// Wooden Arw
	NewAmmoType(1, 1, _ARROW, 0);	// Steel Arw
	NewAmmoType(2, 2, _ARROW, 0);	// Poison Arw
	NewAmmoType(3, 3, _ARROW, 0);	// Razor Arw
	NewAmmoType(4, 4, _ARROW, 0);	// Flame Arw

	// Armor
	NewArmorType(0,  5, CLOTH,   0); // Cloth
	NewArmorType(1, 10, LEATHER, 1); // Leather
	NewArmorType(2, 15, CHAIN,   3); // Chain
	NewArmorType(3, 20, PLATE,   2); // Plate
}

// Gets the damage of a weapon
long GetWeaponDamage(uchar weapon)
{
	return iWeapon[weapon].damage;
}

long GetArrowDamage(uchar bow, uchar arrow)
{
	return iWeapon[bow].damage + iAmmo[arrow].damage;
}

// Gets the defense of armor
long GetArmorDefense(uchar armor)
{
	return iArmor[armor].defense;
}
