// C Source File
// Created 1/18/2008; 10:35:31 AM

//#include "keys.h"
#include "C:\Users\Nick\Documents\C Programming\TI-89 files\MapleCal\MapleCal\keys.h"
//#include "C:\Users\Joseph\Desktop\Calculator Programing stuff\Maplecalc\MapleCal\keys.h"

KEYS keys, prev_keys;

void InitKeys()
{
	keys.Up      = 0;
	keys.Left    = 0;
	keys.Right   = 0;
	keys.Down    = 0;
	keys._2nd    = 0;
	keys.Diamond = 0;
	keys.Alpha   = 0;
	keys.Shift   = 0;
	keys.Esc     = 0;
	keys.Enter   = 0;
	keys.Plus    = 0;
	keys.Minus   = 0;
	keys.Home    = 0;
	keys.F1      = 0;
	keys.F2      = 0;
	keys.F3      = 0;
	keys.F4      = 0;
	keys.F5      = 0;
	
	prev_keys.Up      = 0;
	prev_keys.Left    = 0;
	prev_keys.Right   = 0;
	prev_keys.Down    = 0;
	prev_keys._2nd    = 0;
	prev_keys.Diamond = 0;
	prev_keys.Alpha   = 0;
	prev_keys.Shift   = 0;
	prev_keys.Esc     = 0;
	prev_keys.Enter   = 0;
	prev_keys.Plus    = 0;
	prev_keys.Minus   = 0;
	prev_keys.Home    = 0;
	prev_keys.F1      = 0;
	prev_keys.F2      = 0;
	prev_keys.F3      = 0;
	prev_keys.F4      = 0;
	prev_keys.F5      = 0;
}

void ScanKeys()
{
	ushort Row;
	
	Row = _rowread(0b1111110);
	keys.Up      = Row & 0b00000001;
	keys.Left    = Row & 0b00000010;
	keys.Down    = Row & 0b00000100;
	keys.Right   = Row & 0b00001000;
	keys._2nd    = Row & 0b00010000;
	keys.Shift   = Row & 0b00100000;
	keys.Diamond = Row & 0b01000000;
	keys.Alpha   = Row & 0b10000000;
	Row = _rowread(0b1111101);
	keys.Enter   = Row & 0b00000001;
	keys.Plus    = Row & 0b00000010;
	keys.Minus   = Row & 0b00000100;
	keys.F5      = Row & 0b10000000;
	Row = _rowread(0b1111011);
	keys.F4      = Row & 0b10000000;
	Row = _rowread(0b1110111);
	keys.F3      = Row & 0b10000000;
	Row = _rowread(0b1101111);
	keys.F2      = Row & 0b10000000;
	Row = _rowread(0b1011111);
	keys.F1      = Row & 0b10000000;
	keys.Home    = Row & 0b01000000;
	Row = _rowread(0b0111111);
	keys.Esc     = Row & 0b00000001;
	
	if(keys.Left && keys.Right)
	{
		if(prev_keys.Left)
		{
			keys.Left = 1;
			keys.Right = 0;
		}
		else
		{
			keys.Left = 0;
			keys.Right = 1;
		}
	}
}

void SetPrevKeys()
{
	prev_keys.Up      = keys.Up;
	prev_keys.Left    = keys.Left;
	prev_keys.Right   = keys.Right;
	prev_keys.Down    = keys.Down;
	prev_keys._2nd    = keys._2nd;
	prev_keys.Diamond = keys.Diamond;
	prev_keys.Alpha   = keys.Alpha;
	prev_keys.Shift   = keys.Shift;
	prev_keys.Esc     = keys.Esc;
	prev_keys.Enter   = keys.Enter;
	prev_keys.Plus    = keys.Plus;
	prev_keys.Minus   = keys.Minus;
	prev_keys.Home    = keys.Home;
	prev_keys.F1      = keys.F1;
	prev_keys.F2      = keys.F2;
	prev_keys.F3      = keys.F3;
	prev_keys.F4      = keys.F4;
	prev_keys.F5      = keys.F5;
}





