// Header File
// Created 1/24/2008; 4:34:41 PM

#ifndef __MAP_H__
#define __MAP_H__

/*#include "globals.h"
#include "enemy.h"
#include "item.h"*/

#include "C:\Users\Nick\Documents\C Programming\TI-89 files\MapleCal\MapleCal\globals.h"
#include "C:\Users\Nick\Documents\C Programming\TI-89 files\MapleCal\MapleCal\enemy.h"
#include "C:\Users\Nick\Documents\C Programming\TI-89 files\MapleCal\MapleCal\item.h"

/*#include "C:\Users\Joseph\Desktop\Calculator Programing stuff\Maplecalc\MapleCal\globals.h"
#include "C:\Users\Joseph\Desktop\Calculator Programing stuff\Maplecalc\MapleCal\enemy.h"
#include "C:\Users\Joseph\Desktop\Calculator Programing stuff\Maplecalc\MapleCal\item.h"*/

#define MAX_DROPS 30

typedef struct
{
	short eX;
	short eY;

	short pX;
	short pY;

	uchar area;
	uchar map;
	uchar door;
} DOOR_DATA;

typedef struct 
{
	// Name of the map
	char name[20];
	
	// Sizes
	uchar mapX;
	uchar mapY;
	uchar numOfEnemies;
	uchar numOfDrops;
	uchar numOfDoors;
	uchar tileSet;

	// indices
	uchar *terrain;
	short *doorI;
	DOOR_DATA *door;
	ENEMY_DATA *enemies;
	DROP_DATA drops[MAX_DROPS];

} MAP;

typedef struct 
{
	// Name of the map
	char name[20];
	
	// Sizes
	uchar mapX;
	uchar mapY;
	uchar numOfEnemies;
	uchar numOfDrops;
	uchar numOfDoors;
	uchar tileSet;

	// indices
	uchar *terrain;
	short *doorI;
	DOOR_DATA *door;
	ENEMY_DATA *enemies;

} MAP_F;

extern uchar numOfMaps;
extern MAP *map;

// Load Area
void LoadArea(uchar area);

// Creation & destruction
void InitializeMaps();
void SetMaps(uchar size);
void DestructMaps();

// Enemy & Drops
void ResetMapEnemies();
void DamageEnemy(uchar i, long damage, char dir);
void DropEnemyItems(uchar i);
void DrawItemDrops();
void RemoveDrop(uchar i);

#endif // __MAP_H__
