// C Source File
// Created 1/17/2008; 8:14:21 PM

/*#include "player.h"
#include "skill.h"
#include "graphics.h"
#include "extgraph.h"
#include "tiles.h"
#include "sprites.h"
#include "map.h"
#include "item.h"
#include "itemtype.h"
#include "keys.h"*/

#include "C:\Users\Nick\Documents\C Programming\TI-89 files\MapleCal\MapleCal\player.h"
#include "C:\Users\Nick\Documents\C Programming\TI-89 files\MapleCal\MapleCal\skill.h"
#include "C:\Users\Nick\Documents\C Programming\TI-89 files\MapleCal\MapleCal\graphics.h"
#include "C:\Users\Nick\Documents\C Programming\TI-89 files\MapleCal\MapleCal\extgraph.h"
#include "C:\Users\Nick\Documents\C Programming\TI-89 files\MapleCal\MapleCal\tiles.h"
#include "C:\Users\Nick\Documents\C Programming\TI-89 files\MapleCal\MapleCal\sprites.h"
#include "C:\Users\Nick\Documents\C Programming\TI-89 files\MapleCal\MapleCal\map.h"
#include "C:\Users\Nick\Documents\C Programming\TI-89 files\MapleCal\MapleCal\keys.h"

/*#include "C:\Users\Joseph\Desktop\Calculator Programing stuff\Maplecalc\MapleCal\player.h"
#include "C:\Users\Joseph\Desktop\Calculator Programing stuff\Maplecalc\MapleCal\skill.h"
#include "C:\Users\Joseph\Desktop\Calculator Programing stuff\Maplecalc\MapleCal\graphics.h"
#include "C:\Users\Joseph\Desktop\Calculator Programing stuff\Maplecalc\MapleCal\extgraph.h"
#include "C:\Users\Joseph\Desktop\Calculator Programing stuff\Maplecalc\MapleCal\tiles.h"
#include "C:\Users\Joseph\Desktop\Calculator Programing stuff\Maplecalc\MapleCal\sprites.h"
#include "C:\Users\Joseph\Desktop\Calculator Programing stuff\Maplecalc\MapleCal\map.h"
#include "C:\Users\Joseph\Desktop\Calculator Programing stuff\Maplecalc\MapleCal\keys.h"*/

#define TILE_X ((x<<5) - engine.x)
#define TILE_Y ((y*30) - engine.y)

#define PLAYER_TILE_OVERLAP(X, Y, i, j) BOX_OVER_LAP(X, Y, X+15, Y+34, ((i<<5) - engine.x) + MAP_TILE(j, i).x1, ((j*30) - engine.y) + MAP_TILE(j, i).y1, ((i<<5) - engine.x) + MAP_TILE(j, i).x2, ((j*30) - engine.y) + MAP_TILE(j, i).y2)
#define PLAYER_DANGER_S_OVERLAP(X, Y, i, j) BOX_OVER_LAP(X, Y, X+15, Y+34, ((i<<5) - engine.x), ((j*30) - engine.y) + 24, ((i<<5) - engine.x) + 31, ((j*30) - engine.y) + 29)


Player player;

// Checks over-laps with tiles
char CheckWeaponOverlap(uchar type);

// Initializes the variables
void InitializePlayer()
{	
	player.health = 50;
	player.maxHealth = 50;
	player.magic = 20;
	player.maxMagic = 20;

	player.ammo = 3;
	player.weapon = 8;
	player.armor = 33;
	player.items[3] = 30;
	player.items[8] = 1;
	player.items[13] = 1;
	player.items[18] = 1;
	player.items[23] = 1;
	player.items[28] = 1;

	player.items[33] = 1;
	player.items[34] = 1;
	//player.items[35] = 1;
	//player.items[36] = 1;

	player.direction = FORWARD;
	
	player.F_Key[0] = -1;
	player.F_Key[1] = -1;
	player.F_Key[2] = -1;
	player.F_Key[3] = -1;
	player.F_Key[4] = -1;
	
	player.level = 1;

	player.abilites[0] = &player.strength;
	player.abilites[1] = &player.dexterity;
	player.abilites[2] = &player.intelligence;
	player.abilites[3] = &player.luck;
	
	player.skills[0] = player.beginner_skills;
	player.skills[1] = player.warrior_skills;
	player.skills[2] = player.bowman_skills;
	player.skills[3] = player.magician_skills;
}

// Creates the player using user inputs
void CreatePlayer()
{
	char directions[] = "Pick Head.";
	uchar _head = 0;

	while(!keys.Enter && !keys._2nd)
	{
		ClearBuffers();

		GrayDrawStr2B(60, 30,directions, A_NORMAL, engine.light_vscreen, engine.dark_vscreen);
		GrayClipSprite16_SMASK_R(68, 55, 15, head[_head], head[_head]+15, head[_head]+30, engine.light_vscreen, engine.dark_vscreen);

		ScanKeys();

		if(keys.Left && !prev_keys.Left && _head-- == 0) _head = HEADS-1;
		if(keys.Right && !prev_keys.Right && ++_head == HEADS) _head = 0;

		SetPrevKeys();

		CopyBuffers();
	}

	player.head = _head;
	char stats[4];
	uchar i;
	keys._2nd = 1;
	prev_keys._2nd = 0;

	while(!keys.Shift)
	{
		if(keys._2nd && !prev_keys._2nd)
		{
			for(i = 0; i < 4; i++)
				stats[i] = 4;

			for(i = 0; i < 9; i++)
				stats[random(4)]++;
		}

		SetPrevKeys();
		ScanKeys();

		char num[5];

		ClearBuffers();
		
		GrayDrawStr2B(3, 35, "Strength", A_NORMAL, engine.light_vscreen, engine.dark_vscreen);
		GrayDrawStr2B(3, 43, "Dexterity", A_NORMAL, engine.light_vscreen, engine.dark_vscreen);
		GrayDrawStr2B(3, 51, "Intelligence", A_NORMAL, engine.light_vscreen, engine.dark_vscreen);
		GrayDrawStr2B(3, 59, "Luck", A_NORMAL, engine.light_vscreen, engine.dark_vscreen);

		for(i = 0; i < 4; i++)
		{
			sprintf(num, "%d", stats[i]);
			GrayDrawStr2B(55, 35+i*8, num, A_NORMAL, engine.light_vscreen, engine.dark_vscreen);
		}
		
		GrayDrawStr2B(80, 40, "2nd = Re-roll", A_NORMAL, engine.light_vscreen, engine.dark_vscreen);
		GrayDrawStr2B(80, 50, "Shift = Keep", A_NORMAL, engine.light_vscreen, engine.dark_vscreen);

		CopyBuffers();
	}

	player.strength = stats[0];
	player.dexterity = stats[1];
	player.intelligence = stats[2];
	player.luck = stats[3];
}

// Moves the player
void SetPlayerPos(ushort x, ushort y)
{
	player.xPos = x;
	player.yPos = y;
}

// Moves the player
void MoveVel()
{
	if(player.yVel) MoveY(player.yVel);
	if(player.xVel) MoveX(player.xVel);
}

// Trys to move the screen x, but returns the actual amount moved
short MoveScreenX(short x)
{
	if(x + engine.x < 0)
	{
		x = -engine.x;
		engine.x = 0;
	}
	else if(x + engine.x > MAP_WIDTH - SCREEN_WIDTH - 1)
	{
		x = (MAP_WIDTH - SCREEN_WIDTH - 1) - engine.x;
		engine.x = MAP_WIDTH - SCREEN_WIDTH - 1;
	}
	else
	{
		engine.x += x;
	}

	return x;
}

void MoveX(short x)
{
	short tempX = player.xPos + x;
	
	player.tile = CheckTileOverlap(tempX, player.yPos, 1);
	if(player.tile != -1)
	{
		if(tiles[map[engine.mapI].terrain[player.tile]].boxType & WALKABLE_SURFACE)
		{
			if(x > 0) x = ((((player.tile%MAP_X)<<5)-engine.x) + tiles[map[engine.mapI].terrain[player.tile]].x1 - 16) -  player.xPos;
			else      x = ((((player.tile%MAP_X)<<5)-engine.x) + tiles[map[engine.mapI].terrain[player.tile]].x2 +  1) -  player.xPos;
		}
		else if(tiles[map[engine.mapI].terrain[player.tile]].boxType & DANGER_SURFACE)
		{
			if(x > 0) x = ((((player.tile%MAP_X)<<5)-engine.x) + tiles[1].x1 - 16) -  player.xPos;
			else      x = ((((player.tile%MAP_X)<<5)-engine.x) + tiles[1].x2 + 1) -  player.xPos;
		}
		
		tempX = player.xPos + x;
	}

	if((tempX < 45 && x < 0) || (tempX > 100 && x > 0))
		tempX -= MoveScreenX(x);
	
	if(x)
	{
		player.still_time = 0;
		player.xPos = tempX;
	}
}

// Trys to move the screen y, but returns the actual amount moved
short MoveScreenY(short y)
{
	if(y + engine.y < 0)
	{
		y = -engine.y;
		engine.y = 0;
	}
	else if(y + engine.y > MAP_HEIGHT - SCREEN_HEIGHT - 1)
	{
		y = (MAP_HEIGHT - SCREEN_HEIGHT - 1) - engine.y;
		engine.y = MAP_HEIGHT - SCREEN_HEIGHT - 1;
	}
	else
	{
		engine.y += y;
	}

	return y;
}

void MoveY(short y)
{
	y *= -1;
	short tempY = player.yPos + y;
	
	player.tile = CheckTileOverlap(player.xPos, tempY, 1);
	if(player.tile != -1) 
	{
		if(tiles[map[engine.mapI].terrain[player.tile]].boxType & WALKABLE_SURFACE)
		{
			if(y < 0) y = ((((player.tile/MAP_X)*30)-engine.y) + tiles[map[engine.mapI].terrain[player.tile]].y2 + 1) - player.yPos;
			else      y = ((((player.tile/MAP_X)*30)-engine.y) + tiles[map[engine.mapI].terrain[player.tile]].y1 - 35) - player.yPos;
		}
		else if(tiles[map[engine.mapI].terrain[player.tile]].boxType & DANGER_SURFACE)
		{
			if(y < 0) y = ((((player.tile/MAP_X)*30)-engine.y) + tiles[1].y2 + 1) - player.yPos;
			else      y = ((((player.tile/MAP_X)*30)-engine.y) + tiles[1].y1 - 35) - player.yPos;
		}
		
		if(player.yVel < 0) player.jump_time = 0;
		else                player.jump_time += 20;
		
		if(player.xVel != 0)
		{
			player.xVel = 0;
		}
		
		player.yVel = 0;
		
		tempY = player.yPos + y;
	}

	// Move Screen to keep player with in boundries
	if((tempY < 20 && y < 0) || (tempY > 30 && y > 0))
		tempY -= MoveScreenY(y);
	
	// Set new player position
	if(y)
	{
		player.still_time = 0;
		player.yPos = tempY;
	}
}

void AccelerateY(short yAcel)
{
	player.yVel += yAcel;
	if(player.yVel < TERMINAL_VEL)
		player.yVel = TERMINAL_VEL;
}

// Attacks
void Attack()
{ 
	if(player.attack > 0 && (engine.iteration % (((DRAW_SPEED+1)>>1) * (2*iWeapon[items[player.weapon].useIndex].speed+4))) == 0)
	{
		// All Melee Weapons
		if(player.attack == 2)
		{
			if(iWeapon[items[player.weapon].useIndex].type != BOW)
			{
				long dmg[2];
				GetDamage(dmg);

				char e = CheckWeaponOverlap(0);
				long damage = random(dmg[0]-dmg[1]) + dmg[1];
				if(e != -1)
				{
					if(EnemyGetHit(MAP_ENEMY(e).index))	
						DamageEnemy(e, damage, player.direction);
					else
						NewFString(miss, MAP_ENEMY(e).x, MAP_ENEMY(e).y - 10);
				}
			}
		}
		// Bows
		else if(player.attack == 1)
		{
			if(player.items[player.ammo] > 0 && iWeapon[items[player.weapon].useIndex].type == BOW)
			{
				long dmg[2];
				GetDamage(dmg);

				long damage = random(dmg[0]-dmg[1]) + dmg[1];
				player.items[player.ammo]--;
				if(player.direction == FORWARD)
					AddArrow(player.xPos + engine.x + 16, player.yPos + 17 + engine.y, FORWARD, damage);
				else
					AddArrow(player.xPos + engine.x - 8, player.yPos + 17 + engine.y, BACKWARD, damage);
			}
		}
		
		player.attack++;
		if(player.attack > 2) 
			player.attack = 0;
	}
}

void MagicAttack()
{
	if(player.magic_time & 0x03)
	{
		long dmg[2];
		GetMagicDamage(dmg);

		char e = CheckWeaponOverlap(1);
		long damage = random(dmg[0]-dmg[1]) + dmg[1];
		if(e != -1)
			DamageEnemy(e, damage, player.direction);
	}
}

// Check overlap with tiles
short CheckTileOverlap(short playerX, short playerY, uchar ignoreDanger)
{
	short x1 = max((engine.x + playerX) >> 5, 0);
	short x2 = min((engine.x + playerX + 15) >> 5, MAP_X-1);
	short x;
	
	short y1 = max((engine.y + playerY) / 30, 0);
	short y2 = min((engine.y + playerY + 34) / 30, MAP_Y-1);
	short y;
	
	if(ignoreDanger == 1)
	{
		for(y = y1; y <= y2; y++)
		for(x = x1; x <= x2; x++)
		{
			if(MAP_TILE(y, x).boxType & WALKABLE_SURFACE && PLAYER_TILE_OVERLAP(playerX, playerY, x, y)) 
				return x + (y*MAP_X);
			else if(MAP_TILE(y, x).boxType & DANGER_SURFACE && PLAYER_DANGER_S_OVERLAP(playerX, playerY, x, y)) 
				return x + (y*MAP_X);
		}
	}
	else if(ignoreDanger == 0)
	{
		for(y = y1; y <= y2; y++)
		for(x = x1; x <= x2; x++)
		{
			if(MAP_TILE(y, x).boxType & DANGER_SURFACE && PLAYER_TILE_OVERLAP(playerX, playerY, x, y)) 
				return x + (y*MAP_X);
		}
	}
	else if(ignoreDanger == 2)
	{
		for(y = y1; y <= y2; y++)
		for(x = x1; x <= x2; x++)
		{
			if(MAP_TILE(y, x).boxType & DOOR && PLAYER_TILE_OVERLAP(playerX, playerY, x, y)) 
				return x + (y*MAP_X);
		}
	}
	
	return -1;
}

// Checks if the weapon hit an enemy
char CheckWeaponOverlap(uchar type)
{
	short x1;
	short x2;
	short y1;
	short y2;
	
	if(type == 0) // Melee
	{
		if(player.direction == FORWARD)
		{
			x1 = engine.x + player.xPos + 15;
			x2 = engine.x + player.xPos + 34;
		}
		else
		{
			x1 = engine.x + player.xPos - 19;
			x2 = engine.x + player.xPos -  1;
		}
		
		y1 = engine.y + player.yPos + 10;
		y2 = engine.y + player.yPos + 25;
	}
	else
	{
		if(player.direction == FORWARD)
		{
			x1 = engine.x + player.xPos + 20;
			x2 = engine.x + player.xPos + 52;
		}
		else
		{
			x1 = engine.x + player.xPos - 37;
			x2 = engine.x + player.xPos - 5;
		}
		
		y1 = engine.y + player.yPos + 20;
		y2 = engine.y + player.yPos + 25;
	}
	
	uchar i;
	for(i = 0; i < map[engine.mapI].numOfEnemies; i++)
		if(MAP_ENEMY(i).currentHP > 0 && BOX_OVER_LAP(x1, y1, x2, y2, MAP_ENEMY(i).x, MAP_ENEMY(i).y, MAP_ENEMY(i).x + GET_ENEMY(i).bytes*8 - 1, MAP_ENEMY(i).y + GET_ENEMY(i).sprite_len - 1)) 
			return i;
	
	return -1;
}

//Checks to see if player hits something that causes damage
void CheckPlayerDamage()
{
	if(player.immune_time) return;
	
	uchar i;
	for(i = 0; i < map[engine.mapI].numOfEnemies; i++)
		if(MAP_ENEMY(i).currentHP > 0 && BOX_OVER_LAP(engine.x + player.xPos, engine.y + player.yPos, engine.x + player.xPos + 15, engine.y + player.yPos + 34, MAP_ENEMY(i).x, MAP_ENEMY(i).y, MAP_ENEMY(i).x + GET_ENEMY(i).bytes*4 - 1, MAP_ENEMY(i).y + GET_ENEMY(i).sprite_len - 1)) 
		{
			// Add damage
			short xDir = MAP_ENEMY(i).x - engine.x - player.xPos;
			short yDir = MAP_ENEMY(i).y - engine.y - player.yPos;
			
			// Hurts player
			long damage = (random(GET_ENEMY(i).strength * 300 / 5) + GET_ENEMY(i).strength * 200 / 5) / 100;
			if(PlayerGetHit(MAP_ENEMY(i).index))
				DamagePlayer(damage, xDir, yDir);
			else
				NewFString(miss, player.xPos + engine.x, player.yPos + engine.y - 10);
			
			return;
		}

	short t = CheckTileOverlap(player.xPos, player.yPos, 0);
	if(t != -1)
	{
		// Add damage
		short xDir = ((t%MAP_X)<<5) + MAP_TILE(t/MAP_X,t%MAP_X).x1 - engine.x - player.xPos;
		short yDir = ((t/MAP_X)*30) + MAP_TILE(t/MAP_X,t%MAP_X).y1 - engine.y - player.yPos;
		
		// Hurts player
		long damage = 20 + iArmor[items[player.armor].useIndex].defense*2;
		DamagePlayer(damage, xDir, yDir);
	}
}

// Does damage to player, sets immune time, checks for death
void DamagePlayer(long amount, short xDir, short yDir)
{
	amount -= iArmor[items[player.armor].useIndex].defense*2;
	if(amount < 0) amount = 0;
	player.immune_time = 10;

	char str[9];
	sprintf(str, "-%ld", amount);
	NewFString(str, player.xPos + engine.x, player.yPos + engine.y - 10);

	if(amount > 0)
	{
		player.health -= amount;
			
		player.xVel = (xDir > 0) ? -4 : 4;
		player.yVel = (yDir > 0) ? 6 : -6;
				
		if(player.health <= 0)
		 {
			// Clear buffer screens
			ClearBuffers();
			
			FontSetSys(F_8x10);
			GrayDrawStr2B(40, 35, "Game Over", A_NORMAL, engine.light_vscreen, engine.dark_vscreen);
			
			// Copy over buffer screen
			CopyBuffers();
			
			do
			{ 
				SetPrevKeys();
				ScanKeys();
			}
			while(!keys.Esc && (!keys._2nd || prev_keys._2nd));
			
			End();
		} 
	}
}

// Draws stats to the screen
void DrawPlayerStats()
{
#ifdef SHOW_HP_MP
	// HP & MP
	GrayClipSprite32_SMASK_R(  0, 95, 5, stats,    stats,    stats+5,  engine.light_vscreen, engine.dark_vscreen);
	GrayClipSprite32_SMASK_R( 63, 95, 5, stats+10, stats+10, stats+15, engine.light_vscreen, engine.dark_vscreen);
	GrayClipSprite32_SMASK_R( 32, 95, 5, stats+20, stats+20, stats+25, engine.light_vscreen, engine.dark_vscreen);
	GrayClipSprite32_SMASK_R( 95, 95, 5, stats+20, stats+20, stats+25, engine.light_vscreen, engine.dark_vscreen);

	if(player.health > 0) GrayFastDrawHLine2B( 9, 9 + (46 * player.health) / player.maxHealth, 97, COLOR_DARKGRAY,  engine.light_vscreen, engine.dark_vscreen);
	if(player.magic > 0)  GrayFastDrawHLine2B(74, 74 + (44 * player.magic) / player.maxMagic,  97, COLOR_LIGHTGRAY, engine.light_vscreen, engine.dark_vscreen);
#endif

#ifdef SHOW_EXP
	// EXP
	GrayClipSprite32_SMASK_R( 53,  0, 5, stats+30, stats+30, stats+35, engine.light_vscreen, engine.dark_vscreen);
	GrayClipSprite32_SMASK_R( 85,  0, 5, stats+20, stats+20, stats+25, engine.light_vscreen, engine.dark_vscreen);
	if(player.experience > 0) GrayFastDrawHLine2B(66, 66 + (42 * player.experience) / GetRequiredExp(player.level),  2, COLOR_BLACK, engine.light_vscreen, engine.dark_vscreen);
#endif

#ifdef SHOW_AMMO
	// AMMO
	char num[6];
	sprintf(num, "%ld", player.items[player.ammo]);
	GrayClipSprite8_SMASK_R(130, 95, 3, arrow, arrow+3, arrow+6, engine.light_vscreen, engine.dark_vscreen);
	GrayDrawStr2B(139, 94, num, A_NORMAL, engine.light_vscreen, engine.dark_vscreen);
#endif

#ifdef SHOW_F_KEYS
	// F keys
	uchar i;
	GrayFastDrawHLine2B(0, 45, 0, COLOR_BLACK, engine.light_vscreen, engine.dark_vscreen);
	GrayFastDrawHLine2B(0, 45, 9, COLOR_BLACK, engine.light_vscreen, engine.dark_vscreen);
	for(i = 0; i < 6; i++)
		GrayFastDrawLine2B(i * 9, 0, i * 9, 9, COLOR_BLACK, engine.light_vscreen, engine.dark_vscreen);
	for(i = 0; i < 5; i++)
		if(player.F_Key[i] != -1)
			GrayClipSprite8_SMASK_R(i*9+1, 1, 8, ITEMSPRITE(player.F_Key[i]), ITEMSPRITE(player.F_Key[i])+8, ITEMSPRITE(player.F_Key[i])+16, engine.light_vscreen, engine.dark_vscreen);
#endif
}

// Picks up an item on the ground
void PickUpItem()
{
	uchar i;
	for(i = 0; i < map[engine.mapI].numOfDrops; i++)
		if(BOX_OVER_LAP(engine.x + player.xPos, engine.y + player.yPos, engine.x + player.xPos + 15, engine.y + player.yPos + 34, map[engine.mapI].drops[i].x, map[engine.mapI].drops[i].y, map[engine.mapI].drops[i].x + 7, map[engine.mapI].drops[i].y + 7)) 
		{
			// Adds to the player's inventory
			player.items[map[engine.mapI].drops[i].index] += map[engine.mapI].drops[i].number;

#ifdef USE_CSTRINGS
			char str[30] = "You picked up ";
			if(map[engine.mapI].drops[i].number == 1)
				sprintf(str+14, "a %s.", items[map[engine.mapI].drops[i].index].name);
			else
				sprintf(str+14, "%ld %s.", map[engine.mapI].drops[i].number, items[map[engine.mapI].drops[i].index].name);
			NewCString(str);
#endif
			
			// Delete the item and return (only pick up one item at a time)
			RemoveDrop(i);
			return;
		}
}

// Use Items
void UseItem(uchar i)
{
	switch(items[i].useType)
	{
	case USEABLE:
		if(player.items[i] > 0)
		{
			player.items[i]--;

			switch(iUseable[items[i].useIndex].usedFor)
			{
			case HP_and_MP:
			case HP:
				player.health = min(player.health + iUseable[items[i].useIndex].amount, player.maxHealth);

				char str[9];
				sprintf(str, "+%hd", iUseable[items[i].useIndex].amount);
				NewFString(str, player.xPos + engine.x, player.yPos + engine.y - 10);

				if(iUseable[items[i].useIndex].usedFor == HP) break;
			case MP:
				player.magic = min(player.magic + iUseable[items[i].useIndex].amount, player.maxMagic);
				break;
			}
		}
		break;
	case AMMO:   player.ammo = i;   break;
	case WEAPON: player.weapon = i; break;
	case ARMOR:  player.armor = i;  break;
	}
}

// Shows the Players inventory
void ShowInventory(uchar inStore)
{
	uchar i, j[4] = {0,0,0,0};
	char x = 0, y = 0;
	char tab = 0;
	char menu = -1;

	const char strUse[]     = "Use Item";
	const char strEquip[]   = "Equip Item";
	const char strDiscard[] = "Discard Item";
	const char strSell[]    = "Sell Item";
	
	uchar num[4] = {0,0,0,0};
	for(i = 1; i < NUM_ITEMS; i++)
		if(player.items[i] > 0)
		{
			switch(items[i].useType)
			{
			case USEABLE: 		num[0]++; break;
			case AMMO:
			case WEAPON: 			num[1]++; break;
			case ARMOR: 			num[2]++; break;
			case COLLECTABLE: num[3]++; break;
			}
		}
	
	uchar indices[4][max(max(num[0], num[1]), max(num[2], num[3]))];
	
	for(i = 1; i < NUM_ITEMS; i++)
		if(player.items[i] > 0)
		{
			switch(items[i].useType)
			{
			case USEABLE: 		indices[0][j[0]++] = i; break;
			case AMMO:
			case WEAPON: 			indices[1][j[1]++] = i; break;
			case ARMOR: 			indices[2][j[2]++] = i; break;
			case COLLECTABLE: indices[3][j[3]++] = i; break;
			}
		}
		
	char zin[8], amount[10] = "x 0000000";
	sprintf(zin, "%ld", player.items[0]);
	char dmg[] = "Dmg 00000 ~ 00000";
	char spd[] = "Spd: 0000000";

	while(!prev_keys.Esc || menu != -1)
	{
		// Clear buffer screens
		ClearBuffers();
		
		// Keys
		ScanKeys();

		if(menu != -1)
		{
			if(prev_keys.Esc) menu = -1;
			if(keys.Enter && !prev_keys.Enter)
			{
				UseItem(indices[(uchar)tab][x+y*9]);
				menu = -1;
			}
		
			if(keys.Up && !prev_keys.Up && --menu < 0) menu = 1;
			if(keys.Down && !prev_keys.Down && ++menu > 1) menu = 0;
		}
		else
		{
			if(keys.Enter && !prev_keys.Enter && x+y*9 < num[(uchar)tab]) menu = 0;

			if(keys.Left && !prev_keys.Left)
			{
				if(keys._2nd) {if(--tab < 0) tab = 3;}
				else if(--x < 0) x = 8;
			}
			if(keys.Right && !prev_keys.Right)
			{
				if(keys._2nd) {if(++tab > 3) tab = 0;}
				else if(++x > 8) x = 0;
			}
		
			if(keys.Up && !prev_keys.Up && --y < 0) y = 8;
			if(keys.Down && !prev_keys.Down && ++y > 8) y = 0;
		}
		
		if(tab < 3)
		{
			if(x+y*9 < num[(uchar)tab])
			{
				if(keys.F1) player.F_Key[0] = indices[(uchar)tab][x+y*9];
				if(keys.F2) player.F_Key[1] = indices[(uchar)tab][x+y*9];
				if(keys.F3) player.F_Key[2] = indices[(uchar)tab][x+y*9];
				if(keys.F4) player.F_Key[3] = indices[(uchar)tab][x+y*9];
				if(keys.F5) player.F_Key[4] = indices[(uchar)tab][x+y*9];
			}
			else
			{
				if(keys.F1) player.F_Key[0] = -1;
				if(keys.F2) player.F_Key[1] = -1;
				if(keys.F3) player.F_Key[2] = -1;
				if(keys.F4) player.F_Key[3] = -1;
				if(keys.F5) player.F_Key[4] = -1;
			}
		}
		
		SetPrevKeys();

		if(menu != -1)
		{
			if(tab == 0) GrayDrawStr2B(90, 45, strUse, A_NORMAL, engine.light_vscreen, engine.dark_vscreen);
			else if(tab == 1 || tab == 2) GrayDrawStr2B(90, 45, strEquip, A_NORMAL, engine.light_vscreen, engine.dark_vscreen);
			GrayDrawStr2B(90, (tab != 3 ? 55 : 45), strDiscard, A_NORMAL, engine.light_vscreen, engine.dark_vscreen);

			if(inStore) GrayDrawStr2B(90, 55, strSell, A_NORMAL, engine.light_vscreen, engine.dark_vscreen);

			GrayInvertRect2B(89, 44+menu*10, 135, 50+menu*10, engine.light_vscreen, engine.dark_vscreen);
		}
		
		for(i = 0; i < 4; i++)
		{
			GrayClipSprite32_XOR_R(32*i, 0, 8, tabs[1+i], ((i == tab) ? tabs[0] : tabs[1+i]), engine.light_vscreen, engine.dark_vscreen);
		}
		
		for(i = 0; i < 10; i++)
		{
			GrayFastDrawHLine2B(0, 81, i * 9 + 8, COLOR_BLACK, engine.light_vscreen, engine.dark_vscreen);
			GrayFastDrawLine2B(i * 9, 8, i * 9, 89, COLOR_BLACK, engine.light_vscreen, engine.dark_vscreen);
		}
		GrayFastDrawHLine2B(0, 159, 8, COLOR_BLACK, engine.light_vscreen, engine.dark_vscreen);
		
		// Items
		for(i = 0; i < num[(uchar)tab]; i++)
		{
			GrayClipSprite8_SMASK_R(((i % 9)*9)+1, ((i / 9)*9)+9, 8, ITEMSPRITE(indices[(uchar)tab][i]), ITEMSPRITE(indices[(uchar)tab][i])+8, ITEMSPRITE(indices[(uchar)tab][i])+16, engine.light_vscreen, engine.dark_vscreen);
			if(indices[(uchar)tab][i] == player.ammo || indices[(uchar)tab][i] == player.weapon || indices[(uchar)tab][i] == player.armor)
				GrayInvertRect2B(((i % 9)*9)+1, ((i / 9)*9)+9, ((i % 9)*9)+8, ((i / 9)*9)+16, engine.light_vscreen, engine.dark_vscreen);
		}
		
		// Cursor
		GrayClipSprite8_XOR_R(x*9+1, y*9+9, 8, cursor, cursor, engine.light_vscreen, engine.dark_vscreen);
		if(x+y*9 < num[(uchar)tab])
		{
			GrayDrawStr2B(83, 10, items[indices[(uchar)tab][x+y*9]].name, A_NORMAL, engine.light_vscreen, engine.dark_vscreen);
			sprintf(amount+2, "%ld", player.items[indices[(uchar)tab][x+y*9]]);
			GrayDrawStr2B(86, 18, amount, A_NORMAL, engine.light_vscreen, engine.dark_vscreen);

			if(tab == 1) // Weapon Tab
			{
				long _dmg[2]; 

				if(items[indices[(uchar)tab][x+y*9]].useType == WEAPON)
				{
					_GetDamage(_dmg, items[indices[(uchar)tab][x+y*9]].useIndex, items[player.ammo].useIndex);
					sprintf(spd+5, "%s", wSpeedNames[iWeapon[items[indices[(uchar)tab][x+y*9]].useIndex].speed]);
				}
				else
				{
					_GetDamage(_dmg, items[player.weapon].useIndex, items[indices[(uchar)tab][x+y*9]].useIndex);
					sprintf(spd+5, "Fastest");
				}

				sprintf(dmg+4, "%ld ~ %ld", _dmg[1], _dmg[0]);
				GrayDrawStr2B(83, 28, dmg, A_NORMAL, engine.light_vscreen, engine.dark_vscreen);
				GrayDrawStr2B(83, 36, spd, A_NORMAL, engine.light_vscreen, engine.dark_vscreen);
			}
		}
		
		// Money
		GrayClipSprite8_SMASK_R(120, 91, 8, itemSprites, itemSprites+8, itemSprites+16, engine.light_vscreen, engine.dark_vscreen);
		GrayDrawStr2B(129, 93, zin, A_NORMAL, engine.light_vscreen, engine.dark_vscreen);
		
		// F keys
		GrayFastDrawHLine2B(0, 45, 90, COLOR_BLACK, engine.light_vscreen, engine.dark_vscreen);
		GrayFastDrawHLine2B(0, 45, 99, COLOR_BLACK, engine.light_vscreen, engine.dark_vscreen);
		for(i = 0; i < 6; i++)
			GrayFastDrawLine2B(i * 9, 90, i * 9, 99, COLOR_BLACK, engine.light_vscreen, engine.dark_vscreen);
		for(i = 0; i < 5; i++)
			if(player.F_Key[i] != -1)
				GrayClipSprite8_SMASK_R(i*9+1, 91, 8, ITEMSPRITE(player.F_Key[i]), ITEMSPRITE(player.F_Key[i])+8, ITEMSPRITE(player.F_Key[i])+16, engine.light_vscreen, engine.dark_vscreen);
		
		// Copy over buffer screen
		CopyBuffers();
	}
}

// Shows the Players stats
void ShowStats()
{
	uchar showPoints = player.lPoints > 0;

	ushort p_abil[] = 
		{ player.strength, player.dexterity, player.intelligence, player.luck};

	uchar i = 0;

	char lvl[] = "Level 00 ----------";
	sprintf(lvl+6, "%d %s", player.level, jobNames[player.job]); 
	char num[] = "000";
	char hp[] = "HP 00000/00000";
	char mp[] = "MP 00000/00000";
	char exp[] = "EXP 00000/00000";
	char dmg[] = "Dmg 00000 ~ 00000";
	char acc[] = "Accur 000";
	char avd[] = "Avoid 000";
	long _dmg[2]; 
	sprintf(hp+3, "%ld/%ld", player.health, player.maxHealth); 
	sprintf(mp+3, "%ld/%ld", player.magic, player.maxMagic); 
	sprintf(exp+4, "%ld/%ld", player.experience, GetRequiredExp(player.level)); 
	char pts[] = "Points: 00";


	while(!prev_keys.Esc)
	{
		// Clear buffer screens
		ClearBuffers();
		
		// Keys
		ScanKeys();

		if(showPoints)
		{
			if(keys.Up && i-- == 0) i = 3;
			else if(keys.Down && ++i > 3) i = 0;

			if(keys.Minus || keys.Left)
			{
				if((*player.abilites[i]) > p_abil[i])
				{ (*player.abilites[i])--; player.lPoints++; }
			}
			else if((keys.Plus || keys.Right) && player.lPoints > 0)
			{ 
				(*player.abilites[i])++; 
				player.lPoints--;
			}
		}
		
		SetPrevKeys();

		GetDamage(_dmg);
		sprintf(dmg+4, "%ld ~ %ld", _dmg[1], _dmg[0]);
		sprintf(acc+6, "%hd", (player.dexterity/4 + player.luck/5));
		sprintf(avd+6, "%hd", (player.dexterity/5 + player.luck/3));

		FontSetSys(F_6x8);
		GrayDrawStr2B(1, 1, "Player\'s Stats", A_NORMAL, engine.light_vscreen, engine.dark_vscreen);
		FontSetSys(F_4x6);
		
		GrayDrawStr2B(3, 15, lvl, A_NORMAL, engine.light_vscreen, engine.dark_vscreen);

		GrayDrawStr2B(3, 25, hp, A_NORMAL, engine.light_vscreen, engine.dark_vscreen);
		GrayDrawStr2B(3, 33, mp, A_NORMAL, engine.light_vscreen, engine.dark_vscreen);
		GrayDrawStr2B(3, 41, exp, A_NORMAL, engine.light_vscreen, engine.dark_vscreen);

		GrayDrawStr2B(3, 55, "Strength", A_NORMAL, engine.light_vscreen, engine.dark_vscreen);
		GrayDrawStr2B(3, 63, "Dexterity", A_NORMAL, engine.light_vscreen, engine.dark_vscreen);
		GrayDrawStr2B(3, 71, "Intelligence", A_NORMAL, engine.light_vscreen, engine.dark_vscreen);
		GrayDrawStr2B(3, 79, "Luck", A_NORMAL, engine.light_vscreen, engine.dark_vscreen);

		GrayDrawStr2B(70, 25, dmg, A_NORMAL, engine.light_vscreen, engine.dark_vscreen);
		GrayDrawStr2B(70, 32, acc, A_NORMAL, engine.light_vscreen, engine.dark_vscreen);
		GrayDrawStr2B(70, 40, avd, A_NORMAL, engine.light_vscreen, engine.dark_vscreen);

		sprintf(num, "%d", player.strength);
		GrayDrawStr2B(55, 55, num, A_NORMAL, engine.light_vscreen, engine.dark_vscreen);

		sprintf(num, "%d", player.dexterity);
		GrayDrawStr2B(55, 63, num, A_NORMAL, engine.light_vscreen, engine.dark_vscreen);

		sprintf(num, "%d", player.intelligence);
		GrayDrawStr2B(55, 71, num, A_NORMAL, engine.light_vscreen, engine.dark_vscreen);

		sprintf(num, "%d", player.luck);
		GrayDrawStr2B(55, 79, num, A_NORMAL, engine.light_vscreen, engine.dark_vscreen);

		if(showPoints)
		{
			GrayClipSprite16_XOR_R(70, 56, 5, minusPlus, minusPlus+5, engine.light_vscreen, engine.dark_vscreen);
			GrayClipSprite16_XOR_R(70, 64, 5, minusPlus, minusPlus+5, engine.light_vscreen, engine.dark_vscreen);
			GrayClipSprite16_XOR_R(70, 72, 5, minusPlus, minusPlus+5, engine.light_vscreen, engine.dark_vscreen);
			GrayClipSprite16_XOR_R(70, 80, 5, minusPlus, minusPlus+5, engine.light_vscreen, engine.dark_vscreen);

			GrayInvertRect2B(2, 54+i*8, 45, 60+i*8, engine.light_vscreen, engine.dark_vscreen);
			
			sprintf(pts+8, "%d", player.lPoints);
			GrayDrawStr2B(90, 67, pts, A_NORMAL, engine.light_vscreen, engine.dark_vscreen);
		}

		// Copy over buffer screen
		CopyBuffers();
	}
}

// Show Abilities
void ShowSkills()
{
	uchar showPoints = player.sPoints > 0;
	uchar changed_tab;
	uchar changed_i;

	uchar tab = 0;
	uchar i = 0, j;

	while(!prev_keys.Esc)
	{
		ClearBuffers();

		// Draw Tabs
		GrayClipSprite32_XOR_R(0, 0, 8, tabs[5], tabs[5*tab], engine.light_vscreen, engine.dark_vscreen);
		if(player.job != 0)
			GrayClipSprite32_XOR_R(32, 0, 8, tabs[5+player.job], tabs[(5+player.job)*(1-tab)], engine.light_vscreen, engine.dark_vscreen);

		// Draw Top line
		GrayFastDrawHLine2B(0, 159, 8, COLOR_BLACK, engine.light_vscreen, engine.dark_vscreen);

		for(j = 0; j < skillSize[tab*player.job]; j++)
		{
			GrayClipSprite8_XOR_R(5, 12+j*10, 8, &skillSprites[skills[tab*player.job][j].sprite*16], &skillSprites[skills[tab*player.job][j].sprite*16]+8, engine.light_vscreen, engine.dark_vscreen);
		}

		GrayInvertRect2B(4, 11+j*10, 14, 21+j*10, engine.light_vscreen, engine.dark_vscreen);

		CopyBuffers();

		ScanKeys();

		if(keys.Up && i-- == 0) i = skillSize[tab*player.job]-1;
		if(keys.Up && ++i > skillSize[tab*player.job]-1) i = 0;

		SetPrevKeys();
	}
}

// Gets the amount of experience to level to the next level, given the current level
// Eq : 1.5(x-1)^3.2 + 15
ulong GetRequiredExp(uchar level)
{
	return (ulong)(pow((float)(level-1), 3.2) * 1.5 + 15);
}



