

//#include "maps.h"
#include "C:\Users\Nick\Documents\C Programming\TI-89 files\MapleCal\MapleCal\Setup\maps.h"

#define __MAP__   a_maps[j][k]
#define __DOOR__  a_maps[j][k].door[l]
#define __ENEMY__ a_maps[j][k].enemies[l]

void InitializeAreas()
{
	uchar i = 0;
	uchar j;

	for(j = 0; j < NUM_AREAS; j++)
	{
		uchar k;
		for(k = 0; k < areaSize[j]; k++)
		{
			__MAP__.mapX = mapSizes[i][1];
			__MAP__.mapY = mapSizes[i][0];

			__MAP__.numOfDoors = doorSizes[i];
			__MAP__.numOfEnemies = enemySizes[i];
			__MAP__.tileSet = tileSets[i];

			__MAP__.terrain =      (uchar*)malloc(__MAP__.mapX * __MAP__.mapY * sizeof(uchar));
			__MAP__.doorI   =      (short*)malloc(__MAP__.numOfDoors * sizeof(short));
			__MAP__.door    =  (DOOR_DATA*)malloc(__MAP__.numOfDoors * sizeof(DOOR_DATA));
			__MAP__.enemies = (ENEMY_DATA*)malloc(__MAP__.numOfEnemies * sizeof(ENEMY_DATA));

			memcpy(__MAP__.terrain, maps[i], __MAP__.mapX * __MAP__.mapY * sizeof(uchar));

			uchar l;
			for(l = 0; l < doorSizes[i]; l++)
			{
				__DOOR__.eX = (doors[i][l*5+0] - 1) << 5; 
				__DOOR__.eY = doors[i][l*5+1] * 30 - 31;; 

				__DOOR__.pX = 38; 
				__DOOR__.pY = 50; 

				if(__DOOR__.eX + SCREEN_WIDTH > (__MAP__.mapX<<5) - 1)
				{
					__DOOR__.pX += __DOOR__.eX - ((__MAP__.mapX<<5) - 1 - SCREEN_WIDTH);
					__DOOR__.eX  = (__MAP__.mapX<<5) - 1 - SCREEN_WIDTH;
				}

				if(__DOOR__.eY + SCREEN_HEIGHT > (__MAP__.mapY*30) - 1)
				{
					__DOOR__.pY += __DOOR__.eY - (__MAP__.mapY*30 - 1 - SCREEN_HEIGHT);
					__DOOR__.eY  = __MAP__.mapY*30 - 1 - SCREEN_HEIGHT;
				}

				__DOOR__.area = doors[i][l*5+4]; 
				__DOOR__.map  = doors[i][l*5+2]; 
				__DOOR__.door = doors[i][l*5+3]; 
				__MAP__.doorI[l] = doors[i][l*5+0] + doors[i][l*5+1] * __MAP__.mapX;
			}

			for(l = 0; l < enemySizes[i]; l++)
			{
				__ENEMY__.index = enemies[i][l*5+0];

				__ENEMY__.box_x0 = enemies[i][l*5+1];
				__ENEMY__.box_y0 = enemies[i][l*5+2];
				__ENEMY__.box_x1 = enemies[i][l*5+3];
				__ENEMY__.box_y1 = enemies[i][l*5+4];
			}

			i++;
		}
	}
}


