// C Source File
// Created 2/3/2008; 1:18:18 PM

//#include "structs.h"
#include "C:\Users\Nick\Documents\C Programming\TI-89 files\MapleCal\MapleCal\Setup\tiles.h"

TILES tileSet0[22];
TILES tileSet1[21];

#define NewTile0(INDEX, BOXTYPE, X1, X2, Y1, Y2)tileSet0[INDEX].sprite = INDEX; tileSet0[INDEX].boxType = BOXTYPE; tileSet0[INDEX].x1 = X1; tileSet0[INDEX].x2 = X2; tileSet0[INDEX].y1 = Y1; tileSet0[INDEX].y2 = Y2;
#define NewTile1(INDEX, BOXTYPE, X1, X2, Y1, Y2)tileSet1[INDEX].sprite = INDEX; tileSet1[INDEX].boxType = BOXTYPE; tileSet1[INDEX].x1 = X1; tileSet1[INDEX].x2 = X2; tileSet1[INDEX].y1 = Y1; tileSet1[INDEX].y2 = Y2;

void CreateTileSet0();
void CreateTileSet1();

void InitializeTiles()
{	
	CreateTileSet0(); // basic set
	CreateTileSet1(); // village set
}

void CreateTileSet0()
{
	// empty
	NewTile0(0, NONE, 0, 0, 0, 0);
	// ground
	NewTile0(1, WALKABLE_SURFACE, 0, 31, 24, 29);
	// left side of block
	NewTile0(2, WALKABLE_SURFACE|PASSABLE_SURFACE, 3, 31, 0, 17);
	// right side of block
	NewTile0(3, WALKABLE_SURFACE|PASSABLE_SURFACE, 0, 26, 0, 17);
	// bottom of door
	NewTile0(4, WALKABLE_SURFACE, 0, 31, 24, 29);
	// top of door
	NewTile0(5, DOOR, 7, 22, 16, 29);
	// ceiling
	NewTile0(6, WALKABLE_SURFACE, 0, 31, 0, 5);
	// right, bottom corner wall
	NewTile0(7, WALKABLE_SURFACE, 1, 31, 0, 29);
	// left, bottom corner wall
	NewTile0(8, WALKABLE_SURFACE, 0, 30, 0, 29);
	// right wall
	NewTile0(9, WALKABLE_SURFACE, 1, 31, 0, 29);
	// left wall
	NewTile0(10, WALKABLE_SURFACE, 0, 30, 0, 29);
	// right, top corner wall
	NewTile0(11, WALKABLE_SURFACE, 1, 31, 0, 29);
	// left, top corner wall
	NewTile0(12, WALKABLE_SURFACE, 0, 30, 0, 29);
	// ground, left corner down
	NewTile0(13, WALKABLE_SURFACE, 1, 31, 24, 29);
	// ground, right corner down
	NewTile0(14, WALKABLE_SURFACE, 0, 30, 24, 29);
	// full
	NewTile0(15, WALKABLE_SURFACE, 0, 31, 0, 29);
	// middle of block
	NewTile0(16, WALKABLE_SURFACE|PASSABLE_SURFACE, 0, 31, 0, 17);
	// small ground spikes
	NewTile0(17, DANGER_SURFACE, 6, 22, 19, 23);
	// large ground spikes
	NewTile0(18, DANGER_SURFACE, 0, 31, 17, 25);
	// small block
	NewTile0(19, WALKABLE_SURFACE|PASSABLE_SURFACE, 3, 26, 0, 17);
	// ceiling, left corner up
	NewTile0(20, WALKABLE_SURFACE, 1, 31, 0, 5);
	// ceiling, right corner up
	NewTile0(21, WALKABLE_SURFACE, 0, 30, 0, 5);
}

void CreateTileSet1()
{
	// empty
	NewTile1(0, NONE, 0, 0, 0, 0);
	// ground
	NewTile1(1, WALKABLE_SURFACE, 0, 31, 24, 29);
	// bottom of door
	NewTile1(2, WALKABLE_SURFACE, 0, 31, 24, 29);
	// top of door
	NewTile1(3, DOOR, 7, 22, 16, 29);
	// bottom of door (house)
	NewTile1(4, WALKABLE_SURFACE, 0, 31, 24, 29);
	// top of door (house)
	NewTile1(5, DOOR, 7, 22, 16, 29);
	// right, bottom corner wall
	NewTile1(6, WALKABLE_SURFACE, 1, 31, 0, 29);
	// left, bottom corner wall
	NewTile1(7, WALKABLE_SURFACE, 0, 30, 0, 29);
	// right wall
	NewTile1(8, WALKABLE_SURFACE, 1, 31, 0, 29);
	// left wall
	NewTile1(9, WALKABLE_SURFACE, 0, 30, 0, 29);
	// right, top corner wall
	NewTile1(10, WALKABLE_SURFACE, 1, 31, 0, 29);
	// left, top corner wall
	NewTile1(11, WALKABLE_SURFACE, 0, 30, 0, 29);
	// ground, left corner down
	NewTile1(12, WALKABLE_SURFACE, 1, 31, 24, 29);
	// ground, right corner down
	NewTile1(13, WALKABLE_SURFACE, 0, 30, 24, 29);
	// full
	NewTile1(14, WALKABLE_SURFACE, 0, 31, 0, 29);
	// house ground
	NewTile1(15, WALKABLE_SURFACE, 0, 31, 24, 29);
	// house wall
	NewTile1(16, NONE, 0, 0, 0, 0);
	// house roof l
	NewTile1(17, NONE, 0, 0, 0, 0);
	// house roof r
	NewTile1(18, NONE, 0, 0, 0, 0);
	// full (no box)
	NewTile1(19, NONE, 0, 0, 0, 0);
	// window house wall
	NewTile1(20, NONE, 0, 0, 0, 0);
}

