// C Source File
// Created 1/29/2008; 1:17:40 PM

/*#include "enemy.h"
#include "graphics.h"
#include "player.h"
#include "extgraph.h"
#include "map.h"
#include "tiles.h"*/

#include "C:\Users\Nick\Documents\C Programming\TI-89 files\MapleCal\MapleCal\enemy.h"
#include "C:\Users\Nick\Documents\C Programming\TI-89 files\MapleCal\MapleCal\graphics.h"
#include "C:\Users\Nick\Documents\C Programming\TI-89 files\MapleCal\MapleCal\player.h"
#include "C:\Users\Nick\Documents\C Programming\TI-89 files\MapleCal\MapleCal\extgraph.h"
#include "C:\Users\Nick\Documents\C Programming\TI-89 files\MapleCal\MapleCal\map.h"
#include "C:\Users\Nick\Documents\C Programming\TI-89 files\MapleCal\MapleCal\tiles.h"

/*#include "C:\Users\Joseph\Desktop\Calculator Programing stuff\Maplecalc\MapleCal\enemy.h"
#include "C:\Users\Joseph\Desktop\Calculator Programing stuff\Maplecalc\MapleCal\graphics.h"
#include "C:\Users\Joseph\Desktop\Calculator Programing stuff\Maplecalc\MapleCal\player.h"
#include "C:\Users\Joseph\Desktop\Calculator Programing stuff\Maplecalc\MapleCal\extgraph.h"
#include "C:\Users\Joseph\Desktop\Calculator Programing stuff\Maplecalc\MapleCal\map.h"
#include "C:\Users\Joseph\Desktop\Calculator Programing stuff\Maplecalc\MapleCal\tiles.h"*/

ENEMY enemies[NUM_OF_ENEMY];

#define ENEMY_TILE_OVERLAP(X, Y, w, h, i, j) BOX_OVER_LAP(X, Y, X+w, Y+h, (i<<5) + MAP_TILE(j, i).x1, (j*30) + MAP_TILE(j, i).y1, (i<<5) + MAP_TILE(j, i).x2, (j*30) + MAP_TILE(j, i).y2)
#define ENEMY_DANGER_S_OVERLAP(X, Y, w, h, i, j) BOX_OVER_LAP(X, Y, X+w, Y+h, (i<<5), (j*30) + 24, (i<<5) + 31, (j*30) + 29)

#define NEW_ENEMY(I, LEN, BYTE, FRAME, SPRITE, SPAWN, STR, DEF, HP, EXP, DROPS, SPEED, AVOID, ACC, FLYING) enemies[I].sprite_len = LEN; enemies[I].bytes = BYTE; enemies[I].frames = FRAME; enemies[I].sprite = SPRITE; enemies[I].spawnTime = SPAWN; enemies[I].strength = STR; enemies[I].defense = DEF; enemies[I].maxHP = HP; enemies[I].exp = EXP; enemies[I].numItemsDropped = DROPS; enemies[I].drops = (DROP*)malloc(DROPS * sizeof(DROP)); enemies[I].speed = SPEED; enemies[I].avoid = AVOID; enemies[I].accuracy = ACC; enemies[I].isFlying = FLYING;
#define ENEMY_DROP(I, J, INDEX, CHANCE, NUMBER) enemies[I].drops[J].index = INDEX; enemies[I].drops[J].chance = CHANCE; enemies[I].drops[J].number = NUMBER;
#define SET_ENEMY_JUMP(I, JSPEED, WTIME) enemies[I].jumpSpeed = JSPEED; enemies[I].walkTime = WTIME;

void InitializeEnemies()
{	
	// Enemy 0 - Gumba
	NEW_ENEMY(0, 20, 2, 2, 0, 160, 27, 0, 15, 4, 3, eSLOW, 2, 2, 0);
	ENEMY_DROP(0, 0, ITEM_ZIN, 40, 12);
	ENEMY_DROP(0, 1, ITEM_WOODEN_ARW, 30, 10);
	ENEMY_DROP(0, 2, ITEM_SPIKE_BALL, 80, 1);
	
	// Enemy 1 - Croc
	NEW_ENEMY(1, 30, 2, 2, 120, 200, 40, 3, 65, 8, 3, eNORMAL, 4, 4, 0);
	ENEMY_DROP(1, 0, ITEM_ZIN, 40, 18);
	ENEMY_DROP(1, 1, ITEM_POTION, 15, 1);
	ENEMY_DROP(1, 2, ITEM_WOODEN_ARW, 30, 10);
	
	// Enemy 2 - Spring
	NEW_ENEMY(2, 24, 1, 1, 0, 160, 32, 0, 20, 5, 3, eNORMAL, 6, 1, 0);
	ENEMY_DROP(2, 0, ITEM_ZIN, 40, 12);
	ENEMY_DROP(2, 1, ITEM_ELIXIR, 15, 1);
	ENEMY_DROP(2, 2, ITEM_SPRING, 55, 1);
	SET_ENEMY_JUMP(2, 16, 15);

	// Enemy 3 - Pig
	NEW_ENEMY(3, 22, 4, 1, 0, 180, 70, 10, 120, 20, 4, eFAST, 1, 3, 0);
	ENEMY_DROP(3, 0, ITEM_ZIN, 40, 30);
	ENEMY_DROP(3, 1, ITEM_POTION, 15, 1);
	ENEMY_DROP(3, 2, ITEM_ELIXIR, 15, 1);
	ENEMY_DROP(3, 3, ITEM_WOODEN_ARW, 30, 10);

	// Enemy 4 - Slime
	NEW_ENEMY(4, 13, 2, 1, 300, 160, 42, 5, 50, 10, 2, eNORMAL, 5, 2, 0);
	ENEMY_DROP(4, 0, ITEM_ZIN, 40, 18);
	ENEMY_DROP(4, 1, ITEM_WOODEN_ARW, 30, 20);

	// Enemy 5 - Mushroom
	NEW_ENEMY(5, 15, 2, 1, 339, 140, 52, 0, 80, 15, 2, eNORMAL, 3, 4, 0);
	ENEMY_DROP(5, 0, ITEM_ZIN, 40, 24);
	ENEMY_DROP(5, 1, ITEM_WOODEN_ARW, 30, 20);

	// Enemy 6 - Tentacle
	NEW_ENEMY(6, 30, 4, 2, 66, 140, 90, 5, 200, 100, 2, eNORMAL, 6, 10, 0);
	ENEMY_DROP(6, 0, ITEM_ZIN, 40, 24);
	ENEMY_DROP(6, 1, ITEM_WOODEN_ARW, 30, 20);

	// Create Reverse sprites
	SpriteX8_MIRROR_H(72, enemySprite_8, 1, enemySprite_r_8);
	SpriteX8_MIRROR_H(384, (char*)enemySprite_16, 2, (char*)enemySprite_r_16);
	SpriteX8_MIRROR_H(246, (char*)enemySprite_32, 4, (char*)enemySprite_r_32);
}

void DestructEnemies()
{
	uchar i;
	
	for(i = 0; i < NUM_OF_ENEMY; i++)
		free(enemies[i].drops);
}

// Moves in X
void Enemy_MoveX(uchar i, short x)
{
	short tempX = MAP_ENEMY(i).x + x;
	
	short t = CheckEnemyTileOverlap(tempX, MAP_ENEMY(i).y, GET_ENEMY(i).bytes*8-1, GET_ENEMY(i).sprite_len-1, GET_ENEMY(i).isFlying);
	if(t != -1)
	{
		if(MAP_TILE(t/MAP_X,t%MAP_X).boxType & WALKABLE_SURFACE)
		{
			if(x > 0) x = (((t%MAP_X)<<5) + MAP_TILE(t/MAP_X,t%MAP_X).x1 - GET_ENEMY(i).bytes*8) -  MAP_ENEMY(i).x;
			else      x = (((t%MAP_X)<<5) + MAP_TILE(t/MAP_X,t%MAP_X).x2 + 1) -  MAP_ENEMY(i).x;
		}
		else if(MAP_TILE(t/MAP_X,t%MAP_X).boxType & DANGER_SURFACE)
		{
			if(x > 0) x = (((t%MAP_X)<<5) + tiles[1].x1 - GET_ENEMY(i).bytes*8) -  MAP_ENEMY(i).x;
			else      x = (((t%MAP_X)<<5) + tiles[1].x2 + 1) -  MAP_ENEMY(i).x;
		}

		tempX = MAP_ENEMY(i).x + x;
		
		if(GET_ENEMY(i).isFlying)
		{
			MAP_ENEMY(i).xVel = 0;
			MAP_ENEMY(i).yVel = 0;

			MAP_ENEMY(i).dir *= -1;
			MAP_ENEMY(i).xVel = -MAP_ENEMY(i).dir*random(2)+1;
			MAP_ENEMY(i).yVel = random(6)-3;
		}
		else
		{
			MAP_ENEMY(i).xVel = 0;
			MAP_ENEMY(i).dir *= -1;
		}
	}

	/*if(GET_ENEMY(i).isFlying && -MAP_ENEMY(i).dir != MAP_ENEMY(i).xVel / abs(MAP_ENEMY(i).xVel))
	{
		ushort dx = MAP_ENEMY(i).x - engine.x - player.xPos;

		if(dx)
		{
			//MAP_ENEMY(i).xVel = -2 * (ushort)MAP_ENEMY(i).dir;
			//MAP_ENEMY(i).yVel = MAP_ENEMY(i).xVel * (MAP_ENEMY(i).y - engine.y - player.yPos) / 
			//	                                      (dx);
		}
		else
		{
			//MAP_ENEMY(i).xVel = 0;
			//MAP_ENEMY(i).yVel = ((MAP_ENEMY(i).y - engine.y - player.yPos) < 0 ? 2 : -2 );
		}
	}*/
	
	if(tempX < 15) tempX = 15;
	if(tempX > MAP_WIDTH - 15 - GET_ENEMY(i).bytes*4) 
		tempX = MAP_WIDTH - 15 - GET_ENEMY(i).bytes*4;
	
	MAP_ENEMY(i).x = tempX;
}

// Moves in Y
void Enemy_MoveY(uchar i, short y)
{
	short tempY = MAP_ENEMY(i).y - y;
	
	short t = CheckEnemyTileOverlap(MAP_ENEMY(i).x, tempY, GET_ENEMY(i).bytes*8-1, GET_ENEMY(i).sprite_len-1, GET_ENEMY(i).isFlying);
	if(t != -1) 
	{
		if(MAP_TILE(t/MAP_X,t%MAP_X).boxType & WALKABLE_SURFACE)
		{
			if(y > 0) y = MAP_ENEMY(i).y - (((t/MAP_X)*30) + MAP_TILE(t/MAP_X,t%MAP_X).y2 + 1);
			else      { y = MAP_ENEMY(i).y - (((t/MAP_X)*30) + MAP_TILE(t/MAP_X,t%MAP_X).y1 - GET_ENEMY(i).sprite_len); MAP_ENEMY(i).walkTime++; }
		}
		else if(MAP_TILE(t/MAP_X,t%MAP_X).boxType & DANGER_SURFACE)
		{
			if(y > 0) y = MAP_ENEMY(i).y - (((t/MAP_X)*30) + tiles[1].y2 + 1);
			else      { y = MAP_ENEMY(i).y - (((t/MAP_X)*30) + tiles[1].y1 - GET_ENEMY(i).sprite_len); MAP_ENEMY(i).walkTime++; }
		}
		
		if(GET_ENEMY(i).isFlying)
		{
			MAP_ENEMY(i).xVel = 0;
			MAP_ENEMY(i).yVel = 0;

			while(MAP_ENEMY(i).xVel == 0 || MAP_ENEMY(i).yVel == 0)
			{
				MAP_ENEMY(i).xVel = random(6) - 3;
				MAP_ENEMY(i).yVel = random(6) - 3;
			}
			
			MAP_ENEMY(i).dir = -MAP_ENEMY(i).xVel / abs(MAP_ENEMY(i).xVel);
		}
		else
		{
			if(MAP_ENEMY(i).yVel < 0)
				MAP_ENEMY(i).isJumping = 0;

			if(MAP_ENEMY(i).xVel != 0)
			{
				if(MAP_ENEMY(i).xVel > 0) MAP_ENEMY(i).xVel--;
				else                			MAP_ENEMY(i).xVel++;
			}
			
			MAP_ENEMY(i).yVel = 0;
		}

		tempY = MAP_ENEMY(i).y - y;
	}
	
	MAP_ENEMY(i).y = tempY;
}

// Moves vel
void Enemy_MoveVel(uchar i)
{
	if(GET_ENEMY(i).isFlying)
	{
		if(MAP_ENEMY(i).xVel) Enemy_MoveX(i, GET_ENEMY(i).speed*MAP_ENEMY(i).xVel);
		if(MAP_ENEMY(i).yVel) Enemy_MoveY(i, GET_ENEMY(i).speed*MAP_ENEMY(i).yVel);
	}
	else
	{
		if(MAP_ENEMY(i).xVel) Enemy_MoveX(i, MAP_ENEMY(i).xVel);
		if(MAP_ENEMY(i).yVel) Enemy_MoveY(i, MAP_ENEMY(i).yVel);
	}
}

// Checks over-laps with tiles
short CheckEnemyTileOverlap(short x, short y, short w, short h, uchar flying)
{
	short x1 = (x) >> 5;
	short x2 = (x + w) >> 5;
	short _x;
	
	short y1 = (y) / 30;
	short y2 = (y + h) / 30;
	short _y;
	
	for(_x = x1; _x <= x2; _x++)
	for(_y = y1; _y <= y2; _y++)
	{
		if(flying && MAP_TILE(_y, _x).boxType & PASSABLE_SURFACE)
			continue;
		if(MAP_TILE(_y, _x).boxType & WALKABLE_SURFACE && ENEMY_TILE_OVERLAP(x, y, w, h, _x, _y)) 
			return _x + (_y*MAP_X);
		else if(MAP_TILE(_y, _x).boxType & DANGER_SURFACE && ENEMY_DANGER_S_OVERLAP(x, y, w, h, _x, _y)) 
			return _x + (_y*MAP_X);
	}
	
	return -1;
}

void RandomizePosition(uchar i)
{
	MAP_ENEMY(i).x = random(MAP_ENEMY(i).box_x1 - MAP_ENEMY(i).box_x0 - GET_ENEMY(i).bytes * 8)  + MAP_ENEMY(i).box_x0;
	MAP_ENEMY(i).y = random(MAP_ENEMY(i).box_y1 - MAP_ENEMY(i).box_y0 - GET_ENEMY(i).sprite_len) + MAP_ENEMY(i).box_y0;

	if(GET_ENEMY(i).isFlying)
	{
		while(MAP_ENEMY(i).xVel == 0)
		{
			MAP_ENEMY(i).xVel = random(6) - 3;
			MAP_ENEMY(i).yVel = random(6) - 3;
		}
		
		MAP_ENEMY(i).dir = -MAP_ENEMY(i).xVel / abs(MAP_ENEMY(i).xVel);
	}
}



