// Header File
// Created 2/4/2008; 1:44:56 PM

#ifndef __ITEMTYPE_H__
#define __ITEMTYPE_H__

//#include "globals.h"
#include "C:\Users\Nick\Documents\C Programming\TI-89 files\MapleCal\MapleCal\globals.h"
//#include "C:\Users\Joseph\Desktop\Calculator Programing stuff\Maplecalc\MapleCal\globals.h"

#define NUM_USEABLE 2
#define NUM_COLLECTABLE 1
#define NUM_AMMO 5
#define NUM_WEAPON 25
#define NUM_ARMOR 4

//const short AmmoBaseDmg[] = {4, 0};
//const short WeaponBaseDmg[] = {11, 17, 14, 0, 5};
//const short WeaponDelay[] = {4, 6, 5, 2, 2};
enum wSpeed { W_FASTEST = 0, W_FAST = 1, W_AVERAGE = 2, W_SLOW = 3, W_SLOWEST = 4 };
char wSpeedNames[5][8] = { "Fastest", "Fast", "Average", "Slow", "Slowest" };


// Useable Item
typedef struct
{
	uchar usedFor;
	short amount;
} USEABLE_ITEM;

// Useable Item
typedef struct
{
	
} COLLECTABLE_ITEM;

// Useable Item
typedef struct
{
	short damage;
	uchar type;
	uchar spriteIndex;
} AMMO_ITEM;

// Useable Item
typedef struct
{
	short damage;
	uchar type;
	uchar spriteIndex;
	uchar speed;
} WEAPON_ITEM;

// Useable Item
typedef struct
{
	short defense;
	uchar type;
	uchar spriteIndex;
} ARMOR_ITEM;

// Arrays of items
extern USEABLE_ITEM 		iUseable[NUM_USEABLE];
extern COLLECTABLE_ITEM iCollectable[NUM_COLLECTABLE];
extern AMMO_ITEM 				iAmmo[NUM_AMMO];
extern WEAPON_ITEM 			iWeapon[NUM_WEAPON];
extern ARMOR_ITEM 			iArmor[NUM_ARMOR];

// Populates all of the arrays
void CreateItemTypes();

// Gets the damage of a weapon
long GetWeaponDamage(uchar weapon);
long GetArrowDamage(uchar bow, uchar arrow);

// Gets the defense of armor
long GetArmorDefense(uchar armor);

#endif // __ITEMTYPE_H__
