// C Source File
// Created 1/26/2008; 10:41:40 PM

/*#include "extgraph.h"
#include "graphics.h"
#include "sprites.h"
#include "tiles.h"
#include "map.h"
#include "enemy.h"*/

#include "C:\Users\Nick\Documents\C Programming\TI-89 files\MapleCal\MapleCal\extgraph.h"
#include "C:\Users\Nick\Documents\C Programming\TI-89 files\MapleCal\MapleCal\graphics.h"
#include "C:\Users\Nick\Documents\C Programming\TI-89 files\MapleCal\MapleCal\sprites.h"
#include "C:\Users\Nick\Documents\C Programming\TI-89 files\MapleCal\MapleCal\tiles.h"
#include "C:\Users\Nick\Documents\C Programming\TI-89 files\MapleCal\MapleCal\map.h"
#include "C:\Users\Nick\Documents\C Programming\TI-89 files\MapleCal\MapleCal\enemy.h"

/*#include "C:\Users\Joseph\Desktop\Calculator Programing stuff\Maplecalc\MapleCal\extgraph.h"
#include "C:\Users\Joseph\Desktop\Calculator Programing stuff\Maplecalc\MapleCal\graphics.h"
#include "C:\Users\Joseph\Desktop\Calculator Programing stuff\Maplecalc\MapleCal\sprites.h"
#include "C:\Users\Joseph\Desktop\Calculator Programing stuff\Maplecalc\MapleCal\tiles.h"
#include "C:\Users\Joseph\Desktop\Calculator Programing stuff\Maplecalc\MapleCal\map.h"
#include "C:\Users\Joseph\Desktop\Calculator Programing stuff\Maplecalc\MapleCal\enemy.h"*/





#define ARROW_TILE_OVERLAP(X, i, j) BOX_OVER_LAP(engine.arrows[X].x, engine.arrows[X].y, engine.arrows[X].x+7, engine.arrows[X].y+2, (i<<5) + MAP_TILE(j, i).x1, (j*30) + MAP_TILE(j, i).y1, (i<<5) + MAP_TILE(j, i).x2, (j*30) + MAP_TILE(j, i).y2)

short CheckTileArrowOverlap(uchar i)
{
	short x1 = (engine.arrows[i].x) >> 5;
	short x2 = (engine.arrows[i].x + 7) >> 5;
	
	short y = (engine.arrows[i].y) / 30;
	
	for(; x1 <= x2; x1++)
	{
		if(MAP_TILE(y, x1).boxType && ARROW_TILE_OVERLAP(i, x1, y)) return x1 + (y*MAP_X);
	}
	
	return -1;
}

short CheckEnemyArrowOverlap(uchar a)
{
	uchar i;
	for(i = 0; i < map[engine.mapI].numOfEnemies; i++)
		if(MAP_ENEMY(i).currentHP > 0 && BOX_OVER_LAP(engine.arrows[a].x, engine.arrows[a].y, engine.arrows[a].x + 7, engine.arrows[a].y + 2, MAP_ENEMY(i).x, MAP_ENEMY(i).y, MAP_ENEMY(i).x + GET_ENEMY(i).bytes*4 - 1, MAP_ENEMY(i).y + GET_ENEMY(i).sprite_len - 1)) 
			return i;
	
	return -1;
}

void DeleteArrow(uchar i)
{
	memcpy(&engine.arrows[i], &engine.arrows[--engine.numArrows], sizeof(ARROW));
}

void AddArrow(short x, short y, char dir, long damage)
{
	if(engine.numArrows < MAX_ARROWS)
	{
		engine.arrows[engine.numArrows].x = x;
		engine.arrows[engine.numArrows].y = y;
		engine.arrows[engine.numArrows].dir = dir;
		engine.arrows[engine.numArrows].damage = damage;
		
		engine.numArrows++;
	}
}

void DrawArrows()
{
	uchar i;
	for(i = 0; i < engine.numArrows; i++)
	{
		if(engine.arrows[i].x > engine.x - 8 && engine.arrows[i].x < engine.x + SCREEN_WIDTH &&
			 engine.arrows[i].y > engine.y - 3 && engine.arrows[i].y < engine.y + SCREEN_HEIGHT)
		{
			if(engine.arrows[i].dir == FORWARD)
				GrayClipSprite8_SMASK_R(engine.arrows[i].x - engine.x, engine.arrows[i].y - engine.y, 3, arrow, arrow+3, arrow+6, engine.light_vscreen, engine.dark_vscreen);
			else
				GrayClipSprite8_SMASK_R(engine.arrows[i].x - engine.x, engine.arrows[i].y - engine.y, 3, arrow_r, arrow_r+3, arrow_r+6, engine.light_vscreen, engine.dark_vscreen);
			
			#ifdef DRAW_BOXES
			DrawGrayRect2B(engine.arrows[i].x - engine.x, engine.arrows[i].y - engine.y, engine.arrows[i].x - engine.x + 7, engine.arrows[i].y - engine.y + 2, COLOR_BLACK, 0, engine.light_vscreen, engine.dark_vscreen);
			#endif
		}
	}
}

void MoveArrows()
{
	char i;
	for(i = 0; i < engine.numArrows; i++)
	{
		engine.arrows[(uchar)i].x += ARROW_SPEED * engine.arrows[(uchar)i].dir;
		
		short e = CheckEnemyArrowOverlap(i);
		if(e != -1)
		{
			// Do Damage
			DamageEnemy(e, engine.arrows[(uchar)i].damage, engine.arrows[(uchar)i].dir);
			DeleteArrow(i);
			i--;
			continue;
		}
		
		if(engine.arrows[(uchar)i].x < 0 || 
		   engine.arrows[(uchar)i].x > MAP_WIDTH - 8 || 
		   CheckTileArrowOverlap(i) != -1) 
		{
			DeleteArrow(i);
			i--;
		}
	}
}
