// Header File
// Created 1/22/2008; 1:10:25 PM

#ifndef __TILES_H__
#define __TILES_H__

//#include "globals.h"
#include "C:\Users\Nick\Documents\C Programming\TI-89 files\MapleCal\MapleCal\globals.h"
//#include "C:\Users\Joseph\Desktop\Calculator Programing stuff\Maplecalc\MapleCal\globals.h"

extern uchar numOfTiles;
//#define NUM_TILES 20

enum BoxType 
{ 
	NONE							=	0b00000000, 
	WALKABLE_SURFACE	=	0b00000001, 
	PASSABLE_SURFACE	=	0b00000010,
	DANGER_SURFACE		=	0b00000100,
	DOOR							=	0b00001000 
};

typedef struct 
{
	// sprite
	uchar sprite;
	
	// if the tile has an object in it
	uchar boxType;
	
	// bounding box coordinates of object
	char x1;
	char y1;
	char x2;
	char y2;

} TILES;

extern TILES *tiles;
extern unsigned long *tileSprites;
extern unsigned char *miniTileSprites;

void InitializeTiles();
void SetTiles(uchar size);
void DestructTiles();

#endif // __TILES_H__
